#!/bin/sh
##############################################################################
#
#  Copyright (c) 2005, Doremi Labs, Inc.
#    All rights reserved.
#
#  Redistribution in source or binary forms, with or without
#  modification, are NOT permitted.
#
#    Doremi Labs, Inc.
#    1020 Chestnut St.
#    Burbank, CA 91506
#    Tel : (818) 562 1101
#    Fax : (818) 562 1109
#
##############################################################################

#
# Doremi Labs, Inc.
# 

# If file is bigger than MAXSIZE, we reduce its size to MAXSIZE/2
MAXSIZE_DEFAULT=2097152
MAXSIZE_KREPORT=4194304
MAXSIZE_ODETICSD=4194304
MAXSIZE=${MAXSIZE_DEFAULT}

LOGPATH="/doremi/log"
cd $LOGPATH

echo "Cleaning $LOGPATH..."

# Just a sanity check to be sure...
pwd=`pwd`
if [ "$pwd" != "$LOGPATH" ] ; then
	echo "Can't move to $LOGPATH"
	exit -1
fi

# Let's do it!
files=`ls`
for file in $files ; do
	mime=`file -bi "$file" | cut -d \; -f 1`
	if [ "$mime" = "text/plain" ] ; then
		# Specific MAXSIZE for some log files
                if echo "$file" | grep -q "kreport.log"; then
			MAXSIZE=${MAXSIZE_KREPORT}
		elif echo "$file" | grep -q "odeticsd.log"; then
                        MAXSIZE=${MAXSIZE_ODETICSD}
		else
			MAXSIZE=${MAXSIZE_DEFAULT}
                fi

		size=`stat -c %s "$file"`
		if [ $size -gt $MAXSIZE ] ; then
			mv "$file" "$file.cleaned"
			size=`expr $MAXSIZE / 2`
			echo "[$(date)] *** Truncated by 'cleanlog.sh' ***" > "$file"
			tail -c $size "$file.cleaned" >> "$file"
			rm -f "$file.cleaned"
		fi
	fi
done

# Remove '.xsession-errors' files
find /var/home -name '.xsession-errors' -exec rm -f {} \;

# Reload syslogd for syslog files in $LOGPATH
if [ -x /etc/init.d/sysklogd ]; then
	/etc/init.d/sysklogd reload-or-restart
elif [ -x /etc/init.d/rsyslog ]; then
	/etc/init.d/rsyslog restart
fi

